Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
var cluster_1 = require("cluster");
var isProduction = process.env.NODE_ENV === 'production';
function run(createServer) {
    // In production
    if (isProduction)
        return createServer();
    if (cluster_1.default.isPrimary) {
        console.log('Primary PID ', process.pid);
        startWorker();
    }
    else {
        createServer();
    }
}
exports.run = run;
function startWorker() {
    var worker = cluster_1.default.fork();
    worker.once('disconnect', function () {
        worker.process.kill();
    });
    worker.on('message', function (message) {
        if (message.type === 'reload') {
            if (worker.isDead())
                return;
            console.log('Killing %d', worker.process.pid);
            worker.process.kill();
            startWorker();
        }
    });
}
